// -*- C++ -*- //

#ifndef ALGOWIN_H
#define ALGOWIN_H

class AlgoWin;

#include <all_include.h>
#include <algobox.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

enum {GENERAL, KRUSKAL, ALGO_NUM}; // algorithm IDs;

class AlgoWin : public Gtk::Window
{
private:
  AlgoBox * ab;
  Gtk::Button * runbutton;
  Gtk::Button * closebutton;

protected:
  sigc::signal<void, AlgoWin *> signal_closed;  
  sigc::signal<void, AlgoWin *, std::string> signal_maplist_need;  

public:
  bool closeIfEscapeIsPressed(GdkEventKey* e);

  sigc::signal<void, AlgoWin *> signal_closing();
  sigc::signal<void, AlgoWin *, std::string> signal_maplist_needed();

  void emit_tab_change(std::string);

  AlgoWin(int, std::vector<std::string>);

  void update_tablist(std::vector<std::string> tabnames);
  void update_maplist( void *);

  void on_hide();
};
#endif //ALGOWIN_H
